function net = FeedForwardPass(data , net , netSize ,options)
%FEEDFORWARDPASS Summary of this function goes here
%   Detailed explanation goes here
n = numel(netSize);
net.a = cell(1,n);
net.a{1} = data;
m = size(data , 2);    %sample num
for i=2:n-1
    switch options.activation_function
        case 'sigm'
            net.a{i} = sigmoid(net.W{i - 1} * net.a{i - 1} + net.b{i-1} * ones(1,m));
        case 'tanh_opt'
            net.a{i} = tanh_opt(net.W{i - 1} * net.a{i - 1} + net.b{i-1} * ones(1,m));
    end
end
switch options.output
    case 'sigm'
        net.a{n} = sigmoid(net.W{n - 1} * net.a{n - 1} + net.b{n-1} * ones(1,m));
    case 'tanh_opt'
        net.a{n} = tanh_opt(net.W{n - 1} * net.a{n - 1} + net.b{n-1} * ones(1,m));
    case 'linear'
        net.a{n} = net.W{n - 1} * net.a{n - 1} + net.b{n-1} * ones(1,m);
    case 'softmax'
        net.a{n} = net.W{n - 1} * net.a{n - 1} ;
        net.a{n} = exp(bsxfun(@minus, net.a{n}, max(net.a{n})));
        net.a{n} = bsxfun(@rdivide, net.a{n}, sum(net.a{n}));
end

end

function sigm = sigmoid(z)
sigm = 1./(1 + exp(-z));
end
function tanh = tanh_opt(z)
tanh = (exp(z) - exp(-z)) ./ (exp(z) + exp(-z));
end