% check gradient of the the cost function
clear;
m = 3;   % number of examples

s0 = 7; % input dimension
s1 = 2; % number of hidden units layer 1

lambda = 0.01;                                 % weight decay

d = s1*s0*2 + s1 + s0; 
theta = randn(d, 1);

data = randn(s0, m);
[cost, grad] =  CostGradComputing( theta , data , data ,[s0 s1 s0] );
% [cost, grad] =  basic_autoencoder_cost(theta, s0, s1, ...
%     lambda, data);
eps = 1e-4;

for i=1:d
    thetanew1 = theta;
    thetanew1(i) = theta(i) + eps;
    cost1 =  CostGradComputing( thetanew1 , data , data ,[s0 s1 s0] );
%     cost1 = basic_autoencoder_cost(thetanew1, s0, s1, ...
%     lambda, data);
    thetanew2 = theta;
    thetanew2(i) = theta(i) - eps;
    cost2 =  CostGradComputing( thetanew2 , data , data ,[s0 s1 s0] );
%     cost2 = basic_autoencoder_cost(thetanew2, s0, s1, ...
%     lambda, data);
    numgrad = (cost1 - cost2) / (2*eps);
    diff = abs(grad(i) - numgrad);
    assert(diff < eps, 'numerical check failed\n');
end
fprintf('cool, numerical check passed\n');