


%% AutoEncoder paramter setting
options.Method      = 'CG';
options.maxIter     = 1000;
options.MaxFunEvals = options.maxIter*2;
options.TolX        = 1e-9;
options.display     = 'on';

AEopts.output       = 'sigm';
AEopts.activation_function = 'sigm';
AEopts.lambda       = 0;
b_fine_tune = 0;
ndim = 40*32;

X_input;% dim1 x N
X_output;% dim2 x N
%% pre-processing
if strcmp(AEopts.activation_function, 'tanh_opt')==1
     scale_type = 'linear_scale_minus_1_1';
end
if strcmp(AEopts.activation_function, 'sigm')==1
     scale_type = 'linear_scale_0_1';
end

X_input = (double(NormColumn(X_input, scale_type)));
X_output = (double(NormColumn(X_output, scale_type)));




for nHiddens        = [1000:500:5000]
    for nHiddenLayers   = [3]
        
        netSizes            = [ndim repmat(nHiddens, 1, nHiddenLayers) ndim];
        AESizes             = netSizes;
        model_path = ['..\Model\GradualStackedAE\AE_for_EstimatingFrontal_multipie_' num2str(nHiddens) '_nHiddenLayers_' num2str(nHiddenLayers) '_lambda_' num2str(AEopts.lambda) '_' AEopts.activation_function '_iter_' num2str(options.maxIter) '.mat'];
        
        %% AutoEncoder training
        if ~exist(model_path, 'file')
            SAE = [];
            AEinput             = X_Train_all;
               AEoutput(:,1:num_sample_per_view*k) = repmat(X_Train{k+1},1,k);
               AEoutput(:,num_sample_per_view*(num_view-k)+1:end) = repmat(X_Train{num_view-k},1,k);

               AESizes_k = [netSizes(k) netSizes(k+1) ndim];
               initTheta           = thetaInit( AESizes_k );
               theta               = minFunc( @(p)CostGradComputing( p , AEinput , AEoutput ,AESizes_k, AEopts), initTheta , options);
               
               ae_model                  = theta2WMatrix( theta , AESizes_k );
               
               SAE{k} = ae_model;        
               
               ae = FeedForwardPass( AEinput , ae_model , AESizes_k ,AEopts);
               AEinput = ae.a{end-1};        
            end
            
            ae_model = [];
            for k = 1 : nHiddenLayers
                ae_model.W{k} = SAE{k}.W{1};
                ae_model.b{k} = SAE{k}.b{1};
            end
            ae_model.W{k+1} = SAE{k}.W{2};
            ae_model.b{k+1} = SAE{k}.b{2};
            
            ae = ae_model;
            save(model_path, 'ae','SAE');
        else
            m = load(model_path);
            ae_model = m.ae;
%             SAE = m.SAE;
        end
        
        
        
       %% fine _tune
        if b_fine_tune == 1
            options.maxIter     = 100;
            overall_model_path = ['..\Model\GradualStackedAE\AE_for_EstimatingFrontal_multipie_' num2str(nHiddens) '_nHiddenLayers_' num2str(nHiddenLayers) '_lambda_' num2str(AEopts.lambda) '_' AEopts.activation_function '_fine_tune_iter_' num2str(options.maxIter) '.mat'];

            if ~exist(overall_model_path, 'file')
                AEinput = X_Train_all;  
                AEoutput            = repmat(X_Train{4},1,num_view);
                AESizes         = netSizes;
                initTheta           = thetaInit( AESizes,  ae_model.W, ae_model.b);
                theta               = minFunc( @(p)CostGradComputing( p , AEinput , AEoutput ,AESizes, AEopts), initTheta , options);
                ae_model                  = theta2WMatrix( theta , AESizes );

                ae = ae_model;
                save(overall_model_path, 'ae');
            else
                m = load(overall_model_path);
                ae_model = m.ae;
            end
        end


        b_mult_output = 0;
        num_output = 3;
        if b_mult_output == 1
            ae_model = SAE;
        end
        %% feedforward the testing data and training data
        for i=1:num_view
            test_path_i   = [data_test_path '\multipie_view_' num2str(i) '_test.mat'];
            m = load(test_path_i);
            Xi = (double(NormColumn(m.X, scale_type))); Label = m.Label;
            [X, Label] = FeedForwardPass_feature(Xi, Label , ae_model , AESizes ,AEopts, b_mult_output, num_output);

            test_path{i} = ['..\Model\GradualStackedAE_est_db\mutlipie_view_' num2str(i) '_test.mat'];
            save(test_path{i}, 'X', 'Label');
        end


%         ae                  = FeedForwardPass( X_Train_all , ae_model , AESizes ,AEopts);
%         X_train_est =  [ae.a{end}]; Label_train_est = Label_Train_all;
%         num_output = 2;        
        [X_train_est, Label_train_est] = FeedForwardPass_feature(X_Train_all, Label_Train_all , ae_model , AESizes ,AEopts, b_mult_output, num_output);



        %% PCA and LDA
        lda_model_path = '..\Model\UnifyAE_for_EstimatingFrontal_multipie_lda.mat';
        pca_model_path = '..\Model\UnifyAE_for_EstimatingFrontal_multipie_pca.mat';
        pca_options.b_unified = 1;
        pca_options.b_energy = 0;
        pca_options.energy_ratio = 0.95;
        type = 'sv';
        pca_options.b_train_pca = 1;
        for pca_dim = 100:100:600
            pca_options.pca_dim = pca_dim;
            PCA_LDA_X_save(X_train_est,Label_train_est,pca_model_path, lda_model_path,pca_options);
            pca_options.b_train_pca = 0;
            if strcmp(type,'mv')
                Rate_mLDA_0 = Test_Multiview_LDA_RecognitionMultivew(lda_model_path,  test_path, pca_dim);
                Rate_mLDA = max(Rate_mLDA_0,[],2)';
            end
            if strcmp(type,'sv')
                Rate_mLDA_0 = Test_Multiview_LDA(lda_model_path,  test_path, pca_dim);
            end
            
            Rate_mLDA_frontal = Rate_mLDA_0(:,floor(num_view/2)+1)
            fprintf('nHiddenLayers: %d, nHiddens: %d, lambda:%f, pca: %d, mac(wo diag): %f, mac(diag): %f\n', nHiddenLayers, nHiddens, AEopts.lambda, pca_dim, mean([Rate_mLDA_frontal(1:floor(num_view/2)); Rate_mLDA_frontal(floor(num_view/2)+2:end)]), (sum(Rate_mLDA_0(:)))/(num_view*num_view));
            p = fopen(result_txt_name,'at');
            fprintf(p, 'nHiddenLayers: %d, nHiddens: %d, lambda:%f, pca: %d, mac(wo diag): %f, mac(diag): %f\n', nHiddenLayers, nHiddens, AEopts.lambda, pca_dim,mean([Rate_mLDA_frontal(1:floor(num_view/2)); Rate_mLDA_frontal(floor(num_view/2)+2:end)]), (sum(Rate_mLDA_0(:)))/(num_view*num_view));
            fclose(p);
            
%             fprintf('nHiddenLayers: %d, nHiddens: %d, lambda:%f, pca: %d, mac(wo diag): %f, mac(diag): %f\n', nHiddenLayers, nHiddens, AEopts.lambda, pca_dim,(sum(Rate_mLDA_0(:))-sum(diag(Rate_mLDA_0)))/(num_view*(num_view-1)), (sum(Rate_mLDA_0(:)))/(num_view*num_view));
%             p = fopen('result_stack_ae_multipie.txt','at');
%             fprintf(p, 'nHiddenLayers: %d, nHiddens: %d, lambda:%f, pca: %d, mac(wo diag): %f, mac(diag): %f\n', nHiddenLayers, nHiddens, AEopts.lambda, pca_dim,(sum(Rate_mLDA_0(:))-sum(diag(Rate_mLDA_0)))/(num_view*(num_view-1)), (sum(Rate_mLDA_0(:)))/(num_view*num_view));
%             fclose(p);
        end

        p = fopen(result_txt_name,'at');          fprintf(p, '\n');           fclose(p);

    end
end


