
% digit test
%% load data label
load train_validation_Samples;
inputdata = train_x'./255;
label = train_y';
%%
netSizes = [1521 , 500 , 10];

%% AE train

addpath minFunc/
options.Method = 'lbfgs';
options.maxIter = 10;
options.display = 'on';

AEopts.output = 'sigm';
AEopts.activation_function = 'sigm';
AEopts.lambda = 0.001;

numAE = numel(netSizes) - 2;
SAE = [];
AEinput = inputdata;
for k = 1:numAE
    AESizes = [netSizes(k) netSizes(k+1) netSizes(k)];
    initTheta = thetaInit( AESizes );
    theta = minFunc( @(p)CostGradComputing( p , AEinput , AEinput ,AESizes, AEopts), initTheta , options);
    ae = theta2WMatrix( theta , AESizes );
    ae = FeedForwardPass( AEinput , ae , AESizes ,AEopts);
    SAE.ae{k} = ae;
    AEinput = ae.a{2};
end

%% Fine-tuning
MLPopts.output = 'linear';
MLPopts.activation_function = 'sigm';
MLPopts.lambda = 0.001;

initTheta = addPretrainedW(SAE , netSizes);
theta = minFunc( @(p)CostGradComputing( p , inputdata , label ,netSizes, MLPopts), initTheta , options);
TrainNet = theta2WMatrix( theta , netSizes );
TrainNet = FeedForwardPass( inputdata , TrainNet , netSizes ,MLPopts);
predictlabel = TrainNet.a{end};

TestNet = FeedForwardPass( test_x'/255 , TrainNet , netSizes ,MLPopts);
test_predictlabel = TestNet.a{end};

test_y = test_y';
disp(sum(sum((test_predictlabel - test_y).^2))./(2 * 3466));
