
function theta = optimizeAutoencoderLBFGS(theta , inputdata , label , netSizes , options ,AEopts)


%% Optimization: minibatch L-BFGS

maxIter = floor(size(inputdata,2)/options.batchSize);
for k = 1:options.numepoches
    perm = randperm(size(inputdata,2));
    traindata = inputdata(:,perm);
    for i=1:maxIter
        startIndex = mod((i-1) * options.batchSize, size(traindata,2)) + 1;
        fprintf('startIndex = %d, endIndex = %d\n', startIndex, startIndex + options.batchSize-1);
        batchdata = traindata(:, startIndex:startIndex + options.batchSize-1);
        batchlabel = label(:, startIndex:startIndex + options.batchSize-1);
        [theta, obj] = minFunc( @(p)CostGradComputing( p , batchdata , batchlabel ,netSizes, AEopts), theta , options);
        %     if obj <= finalObjective
        %         trainError = CostGradComputing( theta , data , label ,netSizes );
        %         if trainError <= finalObjective
        %             break
        %         end
        %     end
    end
end
end