function [AE, AESizes, AEopts]= BAE(Xinput_src, Label_src, Xinput_tar, nHiddens, nHiddenLayers, nHiddenLayers_leaf, dae_model_path, dae_init_model_path, Stop, MaxIter_AE, maxIter, lambda)
%% AutoEncoder paramter setting
options.Method      = 'CG';
options.TolX        = 1e-9;
options.display     = 'on';

            
AEopts.output       = 'sigm';
AEopts.activation_function = 'sigm';


Xinput_src = double(Xinput_src);
Xinput_tar = double(Xinput_tar);


%% =====================pretrain==========================================
options.maxIter     = 500;
options.MaxFunEvals = options.maxIter*2;
dae_init_model_path = strrep(dae_init_model_path, '.mat', ['_Iter_' num2str(options.maxIter) '.mat']);
    
[dim, num_sample] = size(Xinput_src);
AEopts.lambda       = lambda;

NetSizes{1} = [dim repmat(nHiddens, 1, nHiddenLayers)];
NetSizes{2} = [repmat(nHiddens, 1, nHiddenLayers_leaf) dim];
NetSizes{3} = [repmat(nHiddens, 1, nHiddenLayers_leaf) dim]; 
            
            
if ~exist(dae_init_model_path,'file')
    Winit = cell(1,3);
    binit = cell(1,3);

    %  pretrain root
    AESizes = [size(Xinput_src,1) repmat(nHiddens, 1, nHiddenLayers) dim*2];
    AEinput_src = Xinput_src;
    AEoutput_src = Xinput_src;
    ZeroOutput = zeros(dim, num_sample);

    AEinput_tar = Xinput_tar;
    AEoutput_tar = Xinput_tar;

    wei = zeros(dim*2,num_sample*2);
    wei(1:dim,1:num_sample) = 1;
%     wei(dim+1:end, num_sample+1:end) = 1;
    wei(dim+1:end, num_sample+1:end) = norm(mean(Xinput_src,2))/norm(mean(Xinput_tar,2));

    AEinput = [AEinput_src AEinput_tar];
    AEoutput = [AEoutput_src  ZeroOutput; ZeroOutput AEoutput_tar];
    mAE_root = stacked_pre_train_single_tree_ae(AEinput, AEoutput,  AESizes, AEopts, wei, options);

    Winit{1} = mAE_root.W(1:end-1);
    binit{1} = mAE_root.b(1:end-1);

%     if strcmp(calss(Winit{1}),'cell')~=1 
%         Winit{1} = mat2cell(Winit{1},1,1);
%     end
    
    if nHiddenLayers_leaf ==0  % no hidden for branch
        a{1} = mAE_root.W{end}(1:dim,:); Winit{2} = a;
        a{1} = mAE_root.b{end}(1:dim,:); binit{2} = a;

        a{1} = mAE_root.W{end}(1+dim:end,:); Winit{3} = a;
        a{1} = mAE_root.b{end}(1+dim:end,:); binit{3} = a;
    else
        %  pretrain left
        ae = FeedForwardPass(Xinput_src, mAE_root, AESizes, AEopts);
        AEinput = ae.a{end-1};
        AEoutput = Xinput_src;
        wei = ones(dim,num_sample);

        AESizes = [repmat(nHiddens, 1, nHiddenLayers_leaf+1) dim];
        mAE = stacked_pre_train_single_tree_ae(AEinput, AEoutput,  AESizes, AEopts, wei, options);

        Winit{2} = mAE.W;
        binit{2} = mAE.b;

        %  pretrain right
        ae = FeedForwardPass(Xinput_tar, mAE_root, AESizes, AEopts);
        AEinput = ae.a{end-1};
        AEoutput = Xinput_tar;
        wei = ones(dim,num_sample);

        AESizes = [repmat(nHiddens, 1, nHiddenLayers_leaf+1) dim];
        mAE = stacked_pre_train_single_tree_ae(AEinput, AEoutput,  AESizes, AEopts, wei, options);

        Winit{3} = mAE.W;
        binit{3} = mAE.b;
%         save(dae_init_model_path_tmp, 'W', 'b', 'NetSizes','AEopts');
    end
    % fine tune with mean
%     options.maxIter     = 200;
%     options.MaxFunEvals = options.maxIter*2;
    AEopts.lambda       = 0;
    gamma = 0.5;
    theta_init = matrix2theta_binarytree(Winit, binit, NetSizes);

    ZeroOutput = zeros(dim, num_sample);
    wei = zeros(dim*2,num_sample*2);
    wei(1:dim,1:num_sample) = 1;
%     wei(dim+1:end, num_sample+1:end) = 1;
    wei(dim+1:end, num_sample+1:end) = norm(mean(Xinput_src,2))/norm(mean(Xinput_tar,2));
    
    AEinput = [Xinput_src Xinput_tar];
    AEoutput = [Xinput_src  ZeroOutput; ZeroOutput Xinput_tar];
       
    
    mean_src = mean(Xinput_src,2);
    mean_tar = mean(Xinput_tar,2);
    AEinput = [AEinput mean_src mean_tar];
    AEoutput = [AEoutput [mean_src; mean_tar] [mean_src; mean_tar]];
    wei = [wei ones(dim*2,2)*num_sample*0.5*gamma];

    theta               = minFunc( @(p)CostGradComputing_weighted_BinaryTree( p , AEinput, AEoutput, NetSizes, AEopts, wei), theta_init , options);
    [Winit, binit] = theta2matrix_binarytree(theta, NetSizes);

    W = Winit;
    b = binit;
    save(dae_init_model_path, 'W', 'b', 'NetSizes','AEopts');
else
    m = load(dae_init_model_path);
    W = m.W;
    b = m.b;
    NetSizes = m.NetSizes;
    AEopts = m.AEopts;
end


%% =====================transfer train==========================================
% NetSizes{1} = [dim repmat(nHiddens, 1, nHiddenLayers)];
% NetSizes{2} = [repmat(nHiddens, 1, nHiddenLayers_leaf) dim];
% NetSizes{3} = [repmat(nHiddens, 1, nHiddenLayers_leaf) dim]; 
theta = matrix2theta_binarytree(W, b, NetSizes);
method = 'nnlasso'; %'lasso'
AEopts.lambda       = lambda;
for iter = 1:maxIter
    
    % load existing model
    dae_model_path_tmp = strrep(dae_model_path, '.mat', ['_iter_' num2str(iter) '.mat']);
    if exist(dae_model_path_tmp, 'file')
        m = load(strrep(dae_model_path, '.mat', ['_iter_' num2str(iter) '.mat']));
        W = m.W;
        b = m.b;
        NetSizes = m.NetSizes;
        AEopts = m.AEopts;
        Beta_tar = m.Beta_tar;
        Beta_src = m.Beta_src;
        theta = matrix2theta_binarytree(W, b, NetSizes);
        continue;
    end

    
    
    stop = Stop(iter);
    options.maxIter     = MaxIter_AE(iter);
    options.MaxFunEvals = options.maxIter*2;

    % forward pass
    Y = FeedForwardPass_BinaryTree(Xinput_src, W, b, NetSizes, AEopts);
    Yinput_src = Y{2}.a{end};
    
    
    Y = FeedForwardPass_BinaryTree(Xinput_tar, W, b, NetSizes, AEopts);
    Yinput_tar = Y{1}.a{end};

    
    Beta_tar = batch_larsso(NormColumn(Xinput_tar,'norm_one'), NormColumn(Yinput_src,'norm_one'), method, stop);
    Beta_src = batch_larsso(NormColumn(Xinput_src,'norm_one'), NormColumn(Yinput_tar,'norm_one'), method, stop);
           

    % basic
    AEoutput_11 = Xinput_src;
    AEoutput_12 = Xinput_src*Beta_src;
    
    
    AEoutput_21 = Xinput_tar*Beta_tar;
    AEoutput_22 = Xinput_tar; 
    

    AEinput = [Xinput_src  Xinput_tar];
    AEoutput= [AEoutput_11 AEoutput_12; AEoutput_21 AEoutput_22];

    
    wei = zeros(dim*2,num_sample*2);
    wei(1:dim,1:num_sample) = 1;
    wei(dim+1:end,1:num_sample) = norm(mean(AEoutput_11,2))/norm(mean(AEoutput_21,2));
    wei(1:dim,num_sample+1:end) = norm(mean(AEoutput_11,2))/norm(mean(AEoutput_12,2));
    wei(dim+1:end,num_sample+1:end) = norm(mean(AEoutput_11,2))/norm(mean(AEoutput_22,2));
   
    theta               = minFunc( @(p)CostGradComputing_weighted_BinaryTree( p , AEinput, AEoutput, NetSizes, AEopts, wei), theta , options);
    

    [W, b] = theta2matrix_binarytree(theta, NetSizes);  
    
    fprintf('**********  iter :%d  ********************** \n', iter);
    save(dae_model_path_tmp, 'W', 'b', 'NetSizes','AEopts','Beta_tar','Beta_src', 'iter');
   
end

iter = maxIter;
save(dae_model_path, 'W','b','NetSizes','AEopts','Beta_tar','Beta_src', 'iter');