function [cost , grad] = CostGradComputing_weighted_BinaryTree(theta , Xinput, Xoutput, NetSizes, options, wei)

lambda = options.lambda;
options.lambda = 0;
num_view = 3;
dim = size(Xinput,1);
Label{1} = Xoutput(1:dim,:);
Label{2} = Xoutput(dim+1:end,:);
%% W, b
[W, b] = theta2matrix_binarytree(theta, NetSizes);
clear theta;
%% cal grad and cost

% left tree
AESize_left = [NetSizes{1} NetSizes{2}];
Wleft = [W{1} W{2}];
bleft = [b{1} b{2}];
Label_left = Label{1};
wei_left = wei(1:dim,:);
[cost_left, dW_left, db_left] = CalGrad_weighted_gpu(Xinput, Label_left, Wleft, bleft, AESize_left, options, wei_left);

% right tree
AESize_right = [NetSizes{1} NetSizes{3}];
Wright = [W{1} W{3}];
bright = [b{1} b{3}];
Label_right = Label{2};
wei_right = wei(dim+1:end,:);
[cost_right, dW_right, db_right] = CalGrad_weighted_gpu(Xinput, Label_right, Wright, bright, AESize_right, options, wei_right);


% clear W;
% clear b;
clear Wleft bleft;
clear Wright bright;
%% grad sum
cost = cost_left + cost_right;
dW = cell(1, num_view);
db = cell(1, num_view);

num_root = length(NetSizes{1});
num_left = length(NetSizes{2});
num_right = length(NetSizes{3});


% root
D = []; B = [];
Wd = W{1};
for i=1:num_root-1  
    D{i} = dW_left{i} + dW_right{i} + lambda * Wd{i};
    B{i} = db_left{i} + db_right{i};
end
dW{1} = D; db{1} = B;

% left
D = []; B = [];
Wd = W{2};
for i=1:num_left
    D{i} = dW_left{num_root-1+i} + lambda * Wd{i};
    B{i} = db_left{num_root-1+i};
end
dW{2} = D; db{2} = B;


% right
D = []; B = [];
Wd = W{3};
for i=1:num_right
    D{i} = dW_right{num_root-1+i} + lambda * Wd{i};
    B{i} = db_right{num_root-1+i};
end
dW{3} = D; db{3} = B;


%% W, b
clear dW_left db_left;
clear dW_right db_right;

grad = matrix2theta_binarytree(dW, db, NetSizes);
%fprintf('.');