function mAE = stacked_pre_train_single_tree_ae(Xinput, Xoutput, AESizes, AEopts, wei, options)

% [dim, num_sample] = size(Xoutput);
AEinput = Xinput;
AEoutput = Xoutput;

mAE = [];
num_layers = length(AESizes);
for k = 1:num_layers-2
    AESizes_k = [AESizes(k:k+1) AESizes(end)];
    initTheta           = thetaInit(AESizes_k);

    initTheta               = minFunc(@(p)CostGradComputing_weighted_gpu( p , AEinput, AEoutput, AESizes_k, AEopts, wei), initTheta , options);       
    AE                 = theta2WMatrix( initTheta , AESizes_k);


    ae = FeedForwardPass(AEinput, AE, AESizes_k, AEopts);
    AEinput = ae.a{2};

    mAE.W{k} = AE.W{1};
    mAE.b{k} = AE.b{1};

    mAE.W{k+1} = AE.W{2};
    mAE.b{k+1} = AE.b{2};
end